 

/**
 * Diese Klasse implementiert das Serververhalten, das im Zustandsdiagramm modelliert wurde
 * @author ISB-Arbeitskreis, Umsetzungshilfen Informatik 12
 * @version 1.0
 */
public class SERVERVERHALTEN {

    /** Konstante f&uuml;r Zustand wartend*/
    private static final int wartend = 0;
    /** Konstante f&uuml;r Zustand gegr&uuml;&szlig;t*/
    private static final int gegruesst = 1;
    /** Konstante f&uuml;r Zustand gefragt*/
    private static final int gefragt = 2;
    /** Konstante f&uuml;r Zustand nochmal*/
    private static final int nochmal = 3;
    /** speichert den aktuellen Zustand*/
    private int zustand = wartend;

    /**
     * ermittelt die zu sendende Antwort in Abh&auml;ngigkeit des Zustands und des Textes, 
     * der vom Client &uuml;bermittelt wurde
     * @param textvomclient der Text, der vom Client an den Server gesendet wurde.
     * @return den Text, der als Antwort an den Client gesendet wird.
     */
    public String HoleAntwort(String textvomclient) {
        String ausgabe = null;

        switch (zustand) {

            case wartend:

                ausgabe = "Hallo!";
                zustand = gegruesst;
                break;

            case gegruesst:

                if (textvomclient.equalsIgnoreCase("Hallo Meister!")) {
                    ausgabe = "Wie geht es Ihnen?";
                    zustand = gefragt;
                } else {
                    ausgabe = "Sie muessen mich mit \"Hallo Meister!\" begruessen! "
                            + "Probieren Sie es nochmal!";
                }
                break;

            case gefragt:

                if (textvomclient.equalsIgnoreCase("gut")) {
                    ausgabe = "Sehr erfreulich. Nochmal (Ja)?";
                    zustand = nochmal;
                } else if (textvomclient.equalsIgnoreCase("schlecht")) {
                    ausgabe = "Das ist sehr schade. Nochmal (Ja)?";
                    zustand = nochmal;
                } else {
                    ausgabe = "Sie koennen nur mit \"gut\" oder \"schlecht\" antworten. "
                            + "Wie geht es Ihnen?";
                }
                break;

            case nochmal:

                if (textvomclient.equalsIgnoreCase("Ja")) {
                    ausgabe = "Hallo!";
                    zustand = gegruesst;
                } else {
                    ausgabe = "Auf Wiedersehen!";
                    zustand = wartend;
                }

                break;
        }
        return ausgabe;
    }
}
