 

import java.io.*;
import java.net.*;

/**
 * Erste Clientimplementierung des Projekts wie gehts?
 * @author ISB-Arbeitskreis, Umsetzungshilfen Informatik 12
 * @version 1.0
 */
public class CLIENT {

    /** bidirektionale Schnittstelle zur Netzwerkprotokoll-Implementierung*/
    private Socket clientSocket = null;
    /** Datenstrom zum Server*/
    private PrintWriter zumServer = null;
    /** Datenstrom vom Server*/
    private BufferedReader vomServer = null;
    /** Datenstrom von der Tastatur*/
    private BufferedReader tastatur = null;
    /** Botschaft vom Server*/
    private String serverBotschaft;
    /** Eingabe von Client an Server*/
    private String clientEingabe;

    /**
     * Konstruktor
     * @exception IOException eine Ausnahme tritt m&ouml;glicherweise auf falls:<br/>
     * - die Clientverbindung nicht hergestellt werden konnte (beispielsweise bei falscher IP-Adresse oder
     * falschem Port)<br/>
     * - die Verbindung zum Server gest&ouml;rt bzw. unterbrochen wurde.
     */
    public CLIENT() throws IOException {

        VerbindungHerstellen();

        //Tastatureingabe, Senden und Empfangen
        while (((serverBotschaft = vomServer.readLine()) != null) && (!serverBotschaft.equals("Auf Wiedersehen!"))) {

            //Serverbotschaft anzeigen.
            System.out.println("Server: " + serverBotschaft);

            //Eingabe vom Client lesen
            clientEingabe = tastatur.readLine();

            //auf die Clientkonsole ausgeben
            System.out.println("Client: " + clientEingabe);
            //und zum Server schicken
            zumServer.println(clientEingabe);
        }

        VerbindungBeenden();
    }

    /**
     * stellt die Serververbindung her und erzeugt die n&ouml;tigen Lese- und Schreibojekte
     * @exception IOException tritt auf, falls die Verbindung nicht korrekt erstellt werden kann.
     */
    private void VerbindungHerstellen() throws IOException {
        //Ipadresse und Port ermitteln
        tastatur = new BufferedReader(new InputStreamReader(System.in));

        System.out.println("IP-Adresse des Servers eingeben:");
        String ipadresse = tastatur.readLine();

        System.out.println("Port eingeben:");
        int port = Integer.parseInt(tastatur.readLine());
        //Verbindung herstellen
        clientSocket = new Socket(ipadresse, port);
        zumServer = new PrintWriter(clientSocket.getOutputStream(), true);
        vomServer = new BufferedReader(new InputStreamReader(clientSocket.getInputStream()));

    }

    /**
     * beendet alle Lese- und Schreibkan&auml;le und die Verbindung zum Server
     * @exception IOException tritt auf, falls eine Verbindung oder ein Stream nicht beendet werden kann.
     */
    private void VerbindungBeenden() throws IOException {
        zumServer.close();
        vomServer.close();
        tastatur.close();
        clientSocket.close();
    }

    /**
     * Hauptprogramm zum Erzeugen eines Clientobjekts
     * @param args keine Parameter beim Programmaufruf erforderlich
     */
    public static void main(String[] args) {

        try {
            new CLIENT();
        } catch (Exception e) {
            System.out.println("Fehler im Clientprogramm.");
            System.exit(1);
        }
    }
}
