 

/**
 * Klasse zur Simulation eines Zuges<br/>
 * der Zugriff auf die freien Pl&auml;tze ist nicht synchronisiert.
 * @author ISB-Arbeitskreis, Umsetzungshilfen Informatik 12
 * @version 1.0
 */
public class ZUG {
    /** die Platznummer im Zug*/
    private int platz = 0;
    /** der Name des Zuges*/
    private String name = "DB";

    /**Konstruktor
     *
     * @param name der Name des Zuges.
     */
    public ZUG(String name) {
        this.name = name;
    }

    /**gibt den Namen des Zuges zur&uuml;ck
     *
     * @return der Name des Zuges
     */
    public String getName() {
        return name;
    }

    /**gibt den n&auml;chsten freien Platz zur&uuml;ck,
     * es wird in aufsteigender Reihenfolge gebucht.
     * 
     * @return der n&auml;chsten freie und damit buchbare Platz
     */
    public int nochFrei() {
        int n = platz; // letzten reservierten Platz lesen
        try {   	// das Lesen braucht etwas Zeit ...
            Thread.sleep((int) (Math.random() * 100));
        } catch (InterruptedException e) {
        }
        platz = n + 1; // naechsten (freien) Platz "ermittlen und belegen"
        return platz; // und zurueckgeben
    }
}
